<style media="screen" type="text/css">
    /*@#page-include#(commonMine.css)*/
</style>


<p id="introText">
    Na ovoj stranici pogledat ćemo i osnovne implementacije sinkronih binarnih brojila.
</p>
<hr>
<div class="header">
    Sinkrona binarna brojila
</div>


<div class="basicText">
    Sinkrona binarna brojila su brojila kod kojih se na sve bistabile dovodi isti signal takta. U sljedećim simulacijama
    tim signalom upravljat će korisnik.
</div>
<hr>

<div class="header">
    Primjer 1.
</div>

<p class="basicText">
    Na simulaciji u nastavku nalazi se sinkrono binarno brojilo. Najprije ćemo popisati specifikacije ove simulacije:
</p>
<hr>
<ul class="listStyle">
    <li>Brojilo mijenja stanje na padajući brid signala takta.</li>
    <li>U lijevom gornjem kutu nalazi se kućica kojom možete mijenjati broj bistabila ovog brojila.</li>
    <li>U desnom gornjem kutu nalazi se kućica kojom možete mijenjati kašnjenje bistabila (ujedno i kašnjenje logičkih
        sklopova) brojila.
    </li>
    <li>Ispod samog brojila nalazi se i vremenski dijagram brojila.</li>
    <li>U simulacijama sinkronih brojila smo radi preglednosti istaknuli one žice koje su važnije. Primjerice, izlazi
        brojila (žice koje prolaze od izlaza bistabila do izlaza brojila) zatamnjeni su u odnosu na žice koje prolaze do
        logičkih sklopova I.
    </li>
</ul>

<hr>

<div class="mlNote">
    <p class="basicText">
        Osvrnut ćemo se na par navedenih točaka.<br><br>
        Vrijeme kašnjenja jednako je za bistabil kao i za logički sklop I, iako je nerealno (ali i moguće..).
        Podešavanjem vremena kašnjenja automatski se resetira vremenski dijagram te se skalira tako da svaki pravokutnik
        traje onoliko koliko je podešeno kašnjenje. Na primjer, podesimo li kašnjenje na 1 sekundu, na dijagramu će
        brojevi <code>1, 2, 3, ... </code> označavati sekunde. Podesimo li pak kašnjenje na 1,5 sekunde, brojevi na
        dijagramu bit će preslikani iz <code>1, 2, 3 ...</code> u <code>1.5, 3, 4.5, ...</code>. Uočite da vrijeme neće
        biti identično pravom vremenu radi velikog broja poslova koje simulacija odrađuje. Isto tako, ako je kašnjenje
        podešeno na 0 milisekundi, dijagram će pokazivati skalu kao za 1 sekundu.

        <br><br>
        Na vremenskom dijagramu nalaze se svi izlazi brojila i signal takta (<b>CP</b>).
    </p>
</div>
<hr>
<p class="basicText">
    Pogledajmo najprije kako je izvedeno sinkrono brojilo. Kao što smo već rekli, signal takta je jedan i doveden je do
    svih bistabila T. Takvo povezivanje omogućuje nam sinkroni rad brojila. Međutim, ovo brojilo ima i dodatnih logičkih
    sklopova I. Ovi sklopovi služe nam za realizaciju sinkronog brojila. Sjećate li se s prethodne stranice tablice
    istinitosti? Iz nje smo zaključili da brojilo treba prebaciti biti veće težine na vrijednost 1 tek kada su svi
    prethodni (bitovi nižih težina) postali 1. Ovom logikom lako možemo uočiti da će nam za promjenu stanja zatrebati
    kombinacijska logika na ulazima bistabila T, koja će omogućiti promjenu stanja bistabila samo onda kada su prethodni
    bistabili u jedinici. <br><br>

    Za početak, pokazat ćemo kako bi to izgledalo sa serijskim prijenosom prethodnih izlaza. Na simulaciji vidimo da smo
    (gledano s lijeva na desno) prvom bistabilu ulaz spojili na vrijednost 1. Time smo omogućili da se <i>bit</i>
    najmanje težine mijenja na svaki padajući brid signala takta. Drugi se bistabil mora mijenjati na svaki drugi
    padajući brid signala takta, pa smo mu za taj uvjet doveli direktno izlaz prvog bistabila. Zatim imamo treći
    bistabil kojem je uvjet za promjenu da su oba prethodna bistabila u jedinici, to smo ostvarili jednim dvoulaznim
    logičkim sklopom I. Slično smo napravili i za posljednji bistabil.
</p>

<p class="basicText">
    Isprobajte ovu simulaciju (bez kašnjenja) tako da generirate padajuće bridove signala takta i pratite dekoder stanja
    te vremenski dijagram. Uočite ciklus brojanja a zatim postavite i kašnjenje. Postoje li tranzijentna stanja?
</p>
<div align="center">
    <canvas id="syncCounter" width="900" height="750"></canvas>
</div>
<hr>
<p class="basicText">
    Ako ste isprobali prethodnu simulaciju uočili ste da sinkrono brojilo ne prolazi kroz dodatna stanja koja ne postoje
    u ciklusu. Međutim, i dalje postoji vrijeme kašnjenja čitavog brojila, koje ćemo sada definirati.<br><br>
    Za sinkrono binarno brojilo sa serijskim prijenosom definiramo vrijeme kašnjenja bistabila \(t_{db}\) i vrijeme
    kašnjenja logičkih sklopova \(t_{dls}\). Za prethodnu simulaciju i navedene parametre, možemo pisati sljedeće:
    $$ n \hskip 2mm (broj \hskip 2mm bistabila) \hskip 2mm = 4 \\
    t_{db} = 1000 \hskip 2mm ms \\
    t_{dls} = 1000 \hskip 2mm ms \\
    T_{d} = t_{db} + (n - 2) \cdot t_{dls} =
    1000 + (4 - 2) \cdot 1000 =
    3000 \hskip 2mm milisekunda =
    3 \hskip 2mm sekunde

    $$

    Vidimo da je kašnjenje ovog brojila svedeno samo na jedno kašnjenje bistabila i \(n - 2\) kašnjenja logičkih
    sklopova. Imamo \(n - 2\) kašnjenja logičkih sklopova na prethodnoj simulaciji zato što prvom i drugom bistabilu
    nije potreban logički sklop I. Tako nam ostaje pričekati \(n - 2\) logička sklopa I kako bi brojilo bilo spremno
    postaviti sljedeće stanje.

    Uz ovu definiciju kašnjenja možemo definirati i maksimalnu frekvenciju rada ovog binarnog brojila sa serijskim
    prijenosom.
    $$
    f_{max} = \frac{1}{T_d} = \frac{1}{t_{setup} + t_{db} + (n - 2) \cdot t_{dls}}
    $$
</p>
<hr>

<div class="header">
    Primjer 2.
</div>

<p class="basicText">
    Na simulaciji u nastavku nalazi se jedno sinkrono binarno brojilo. Ovo brojilo ostvareno je s paralelnim prijenosom
    izlaza. Specifikacije ove simulacije jednake su prethodnoj, jedina razlika je u prijenosu izlaza bistabila.<br><br>

    Pogledamo li način spajanja ovog brojila uočit ćemo sljedeće: prvi, drugi i treći bistabil spojeni su identično kao
    i kod serijskog prijenosa. Razlika počinje tek kod četvrtog bistabila; na njegov ulaz T doveli smo izlaz logičkog
    troulaznog sklopa I. Ovaj sklop je troulazni jer su mu ulazi svi izlazi prethodnog bistabila. Ovakvim povezivanjem
    bistabila, više ne moramo čekati \(n - 2\) logička sklopa I, s obzirom na to da svaki sljedeći bistabil dobiva
    informaciju o izlazima svih prethodnih.
    Probajte dodati par bistabila u ovu simulaciju i uočite da se brzo povećava broj ulaza logičkih sklopova I. Iako smo
    smanjili vrijeme kašnjenja ovog brojila (i povećali maksimalnu frekvenciju rada), povećali smo broj ulaza logičkog
    sklopa I pa za veliki broj bistabila ovakva izvedba nije najefikasnija.

    <br><br>
    Isprobajte ovu simulaciju tako da definirate kašnjenje od 1 ili 2 sekunde te prođete jedan ciklus brojila.

</p>

<hr>
<div align="center">
    <canvas id="syncCounterPar" width="900" height="750"></canvas>
</div>
<hr>

<div class="basicText">
    <p>
        Ako ste isprobali prethodnu simulaciju, mogli ste uočiti koliko je vrijeme kašnjenja ovog brojila. Pa da vidimo,
        najgora situacija za ovako izvedeno brojilo je jedno vrijeme kašnjenja bistabila i jedno vrijeme kašnjenja
        logičkog sklopa I.
        Uočite da sada ne čekamo logičke sklopove I jer svaki dobiva izlaze svih prethodnih bistabila.
        Vrijeme kašnjenja s navedenim parametrima bit će:
        $$ n \hskip 2mm (broj \hskip 2mm bistabila) \hskip 2mm = 6\\
        t_{db} = 1500 \hskip 2mm ms \\
        t_{dls} = 1500 \hskip 2mm ms \\
        T_{d} = t_{db} + t_{dls} =
        1500 + 1500 =
        3000 \hskip 2mm milisekunda =
        3 \hskip 2mm sekunde

        $$

        Uz ovu definiciju kašnjenja možemo definirati i maksimalnu frekvenciju rada sinkronog binarnog brojila s
        paralelnim prijenosom.
        $$
        f_{max} = \frac{1}{T_d} = \frac{1}{t_{setup} + t_{db} + t_{dls}}
        $$
    </p>
</div>


<p class="basicText">
    Sad smo obradili osnovna svojstva sinkronih i asinkronih binarnih brojila. Slijedi i sažetak prethodne dvije
    stranice.
</p>

<ul class="listStyle">
    <li>Sinkrono binarno brojilo je sekvencijski modul koji za brojanje koristi jedinstveni signal takta za sve
        bistabile. Ulaze bistabila povezujemo kombinacijskom logikom kako bi ostvarili uvjete za ispravno brojanje.
        Razlikujemo dvije vrste ovakvih brojila: brojilo s paralelnim te brojilo sa serijskim prijenosom.
    </li>
    <li>Asinkrono binarno brojilo je sekvencijski modul koji za brojanje koristi dijeljenje frekvencije ulaznog signala.
        Naime, prvi bistabil dobit će vanjski signal takta, a ostali bistabili dobit će signal takta izravno od izlaza
        prethodnog bistabila. Ovo brojilo prolazi i kroz različita tranzijentna stanja pa definiramo i vrijeme očitanja
        izlaza brojila.
    </li>
</ul>

<div class="mlNote">
    <p class="basicText">
        Dodatno ćemo ponoviti i osnovna vremena kašnjenja bistabila i osnovnih logičkih sklopova:
    </p>

    <ul class="listStyle">
        <li>\(t_{setup}\) &ndash; minimalno vrijeme prije nailaska djelotvornog brida signala takta nakon kojeg se ulaz
            više ne smije mijenjati kako bi bistabil pouzdano očitao tu vrijednost.
        </li>
        <li>\(t_{očitanja}\) &ndash; vrijeme koje je potrebno dekoderu da očita izlaz brojila</li>
        <li>\(t_{hold}\) &ndash; minimalno vrijeme nakon nailaska djelotvornog brida signala takta u kojem se ulaz i
            dalje ne smije mijenjati, kako bi sklop mogao odreagirati na tu pobudu
        </li>
        <li>
            \(t_{db}\) &ndash; vrijeme koje je potrebno bistabilu da provede dovedenu vrijednost s ulaza prema izlazu
        </li>
    </ul>

</div>
<hr>

<p id="outroText">
    Na sljedećoj stranici pogledat ćemo Johnsonovo i prstenasto brojilo.
</p>

<script>
    /*@#page-include#(library.js)*/
    /*@#page-include#(syncCounter.js)*/
    /*@#page-include#(syncCounterPar.js)*/
</script>